import { KoaMiddleware } from '../types';
interface ICounter {
    increment: (val: number) => void;
    decrement: (val: number) => void;
    get: () => number;
}
/**
 * Try to limit the number of instantaneous concurrent requests
 * @param limit The maximum number of concurrent requests. <= 0 means no limit
 * @param counter A counter object that implements the ICounter interface. If not provided, a LocalCounter will be used
 * @returns
 */
export declare const concurrencyLimitMiddleware: (limit: number, counter?: ICounter) => KoaMiddleware;
export {};
//# sourceMappingURL=concurrency-limit.d.ts.map