"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.contextInjectionMiddleware = void 0;
const invoker_1 = require("../invoker");
const contextInjectionMiddleware = (extendedContextKey, extendedContext) => {
    const enableExtendedContext = extendedContextKey !== '';
    return async (ctx, next) => {
        ctx.state.eventType = 'http';
        ctx.state.timestamp = new Date().toISOString();
        ctx.httpContext = {
            url: ctx.URL.toString(),
            httpMethod: ctx.method,
            headers: { ...ctx.headers }
        };
        if (enableExtendedContext) {
            ctx.httpContext.headers = (0, invoker_1.withoutHeaders)(ctx.headers, [extendedContextKey]);
            ctx.extendedContext = (0, invoker_1.extractExtendedContextFromHeader)(ctx.headers, extendedContextKey);
        }
        else if (extendedContext) {
            ctx.extendedContext = { ...ctx.extendedContext, ...extendedContext };
        }
        await next();
    };
};
exports.contextInjectionMiddleware = contextInjectionMiddleware;
//# sourceMappingURL=context.js.map