"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.functionRouteMiddleware = functionRouteMiddleware;
const function_wrapper_1 = require("../function-wrapper");
const router_1 = require("../router");
function functionRouteMiddleware(routers, options) {
    return async (ctx, next) => {
        let fnName = '';
        if (options.loadAllFunctions) {
            fnName = ctx.query['@fn'];
        }
        const router = routers.get(fnName);
        const { routeDefinition, handleFunction } = (0, router_1.routeFunction)(router, fnName, ctx.path);
        if (routeDefinition) {
            ctx.state.matchedRoute = routeDefinition;
        }
        if (handleFunction && handleFunction.userFunction) {
            return await (0, function_wrapper_1.wrapHandlerFunction)(handleFunction.userFunction, handleFunction.pkgInfo, options.signatureType, options.captureStack)(ctx, next);
        }
    };
}
//# sourceMappingURL=function-route.js.map